﻿using System;
using ToolQit;

namespace SharpRss.Models
{
    public class GroupModel
    {
        public GroupModel(string name)
        {
            Name = name;
            HexColor = Utilities.GenerateRandomHexColor();
            Id = Guid.NewGuid().ToString();
        }
        public string Name { get; set; }
        public string HexColor { get; set; }
        public string Icon { get; set; }
        public string Id { get; private set; }
    }
}
