﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SharpRss.Models
{
	public class FeedItemModel
	{
		/// <summary>
		/// Last time the item is fetched.
		/// </summary>
		public DateTime LastUpdated { get; set; }
		/// <summary>
		/// The feed in which the item is part of.
		/// </summary>
		public string FeedId { get; set; }
		/// <summary>
		/// If the item is read.
		/// </summary>
		public bool Read { get; set; }
		public string Type { get; set; }
		public string Title { get; set; }
		public string Description { get; set; }
		public string Link { get; set; }
		public DateTime? PublishingDate { get; set; }
		public string Author { get; set; }
		public string Id { get; set; }
		public string[] Categories { get; set; }
		public string Content { get; set; }
	}
}
